{-|
Module      : PUBMED.ServantClientLogging
Description : PubMed API integration
Copyright   : (c) CNRS, 20198
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX
-}
module PUBMED.ServantClientLogging where

import qualified Data.Binary.Builder as DBB
import Debug.Trace (trace)
import Servant.Client (ClientEnv(..))
import Servant.Client.Core.Request (RequestF(..))


addLoggingToClientEnv :: ClientEnv -> ClientEnv
addLoggingToClientEnv env@(ClientEnv { makeClientRequest = mcr }) = env { makeClientRequest }
  where
    makeClientRequest baseUrl req =
      trace ("req: " <> showRequestPath req <> " " <> show (requestQueryString req)) $ mcr baseUrl req
    showRequestPath req =
      show $ DBB.toLazyByteString $ requestPath req
